/**********************************************************************
 *               Copyright (C) 2007 Patrick McManus                    *
 *                <mcmanus@ducksong.com>                               *
 *                                                                     *
 *    This program is free software; you can redistribute it and/or    *
 *    modify it under the terms of the GNU General Public License as   *
 *    published by the Free Software Foundation; either version 2 of   *
 *    the License, or (at your option) any later version.              *
 *                                                                     *
 *    This program is distributed in the hope that it will be useful,  *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of   *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    *
 *    GNU General Public License for more details.                     *
 **********************************************************************/


// rev jun 18 2007 r001


// This is a silly little evolution mail plugin that binds one keypress (CTRL F12) to
// move a message to a designated folder - TARGETFOLDER

// I use it to populate a spam aassasin folder on a different server instead of using the 
// bayes tools on my mail reading host

#define TARGETFOLDER 			      "imap://mcmanus@192.168.16.1/train"

#include <stdio.h>
#include <stdlib.h>

#include <mail/em-folder-tree.h>
#include <mail/em-folder-view.h>
#include <mail/mail-ops.h>

// taken from mail-to-task
static void
copy_uids (char *uid, GPtrArray *uid_array) 
{
	g_ptr_array_add (uid_array, g_strdup (uid));
}


void com_ducksong_evolution_junk (void *ep, EMPopupTargetSelect *t)
{
  int i;
  GPtrArray *uid_array = NULL;
  
  
  if (t->uids->len > 0) 
    {
  
      // odd api.. the allocation gets done here, but mail_transfer_messages will do the free
      uid_array = g_ptr_array_new ();
      g_ptr_array_foreach (t->uids, (GFunc)copy_uids, (gpointer) uid_array);
      
      mail_transfer_messages (t->folder,
			      uid_array, 
			      TRUE,
			      TARGETFOLDER,
			      0, 
			      NULL, NULL);
      
    }
  
  return;
}

